package org.amse.asves.skinCreator.model;

import java.util.Collections;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 *      pledit.txt
 * @author 
 *
 */
public enum PleditParameterName {
	
	Normal,
	Current,
	NormalBG,
	SelectedBG,
	MbFG,
	MbBG,
	Font;
	
	/**
	 * @return  ,  
	 */
	public static SortedSet<PleditParameterName> getAllColorParameterNames() {
		SortedSet<PleditParameterName> tmp = new TreeSet<PleditParameterName>();
		tmp.add(PleditParameterName.Normal);
		tmp.add(PleditParameterName.Current); 
		tmp.add(PleditParameterName.NormalBG);
		tmp.add(PleditParameterName.SelectedBG);
		tmp.add(PleditParameterName.MbBG);
		tmp.add(PleditParameterName.MbFG);
		return Collections.unmodifiableSortedSet(tmp);
	}
	
	/**
	 * @return   
	 */
	public static SortedSet<PleditParameterName> getAllParameterNames() {
		SortedSet<PleditParameterName> tmp = new TreeSet<PleditParameterName>();
		tmp.add(PleditParameterName.Normal);
		tmp.add(PleditParameterName.Current); 
		tmp.add(PleditParameterName.NormalBG);
		tmp.add(PleditParameterName.SelectedBG);
		tmp.add(PleditParameterName.MbBG);
		tmp.add(PleditParameterName.MbFG);
		tmp.add(PleditParameterName.Font);
		return Collections.unmodifiableSortedSet(tmp);
	}
	
	/**
	 *     
	 * @param name 
	 * @return null        
	 */
	public static PleditParameterName getValidParameterName(String name){
		String parameterName = name.toUpperCase();
		
		if (parameterName.equals("NORMAL")) {
			return PleditParameterName.Normal;
		}else{
		if (parameterName.equals("CURRENT")) { 
			return PleditParameterName.Current;
		}else{
		if (parameterName.equals("NORMALBG")) {
			return PleditParameterName.NormalBG;
		}else{
		if (parameterName.equals("SELECTEDBG")) {
			return PleditParameterName.SelectedBG;
		}else{
		if (parameterName.equals("MBBG")) {
			return PleditParameterName.MbBG;
		}else{
		if (parameterName.equals("MBFG")) {
			return PleditParameterName.MbFG;
		}else{
		if (parameterName.equals("FONT")) {
			return PleditParameterName.Font;
		}else{
			return null;
		}}}}}}}
	}
}
