package org.amse.asves.skinCreator.reader;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.HashSet;

import org.amse.asves.skinCreator.exceptions.*;
import org.amse.asves.skinCreator.model.ISkin;
import org.amse.asves.skinCreator.model.PleditParameterName;
import org.amse.asves.skinCreator.model.RGBColor;
/**
 *     pledit.txt
 * 
 * @see org.amse.asves.skinCreator.reader.TxtReaderManager
 * @author 
 *
 */
final class PleditReader extends TxtReaderManager {
	
	public void getContent(ISkin skin, BufferedReader reader) throws ErrorReadingProject{
		try{
			HashSet<PleditParameterName> parameters = new HashSet<PleditParameterName>();
			parameters.addAll(PleditParameterName.getAllParameterNames());
			
			String line;
			try{
				line = reader.readLine();
			}catch (IOException e){
				throw new ErrorReadingProject("   pledit.txt");
			}
    		/**
    		 *   20   
    		 */
    		for (int counter = 0; (line != null) && (!parameters.isEmpty()) ; counter++){
   				int equalityPlace = line.indexOf("=");
   				if (equalityPlace != -1){
   					PleditParameterName name;
   					String param = line.substring(0,equalityPlace).trim();
   					String value = line.substring(equalityPlace+1).trim();
   					name = PleditParameterName.getValidParameterName(param);
   					
   					if (name == null) throw new InvalidFile("pledit.txt");
   					
   					/**
   					 *        
   					 *  
   				 	*/
   					if (parameters.contains(name)){
   						parameters.remove(name);
  						//textFile.setParameter(name, value);
  						if (name == PleditParameterName.Font){
   							skin.setFont(value);
   						}else{
   							RGBColor color = new RGBColor();
   							try{
   								color.encodeFromHexadecimal(value);
   							}catch(InvalidValueException e) {
   								throw new InvalidFile("pledit.txt");
   							}
   							skin.setPleditColor(name, color);
   						}
   					}
   				}
   				try{
   					line = reader.readLine();
   				}catch (IOException e){
   					throw new ErrorReadingProject("   pledit.txt");
   				}
    		}
    		
   		}finally{
       	}
   		try{
   			for (PleditParameterName name : PleditParameterName.getAllColorParameterNames())
   				if (skin.getPleditColor(name) == null)
   					skin.setPleditColor(name, new RGBColor(-1,0,0));
   		}catch(Exception e){
   			
   		}
	}
	
	public String getFileName(){
		return "pledit.txt";
	}
}
