package org.amse.asves.skinCreator.reader;

import java.io.BufferedReader;
import java.io.IOException;

import org.amse.asves.skinCreator.exceptions.*;
import org.amse.asves.skinCreator.model.ISkin;
import org.amse.asves.skinCreator.model.RGBColor;

/**
 *     viscolor.txt
 * 
 * @see org.amse.asves.skinCreator.reader.TxtReaderManager
 * @author 
 *
 */
final class ViscolorReader extends TxtReaderManager {
	
	private static String getStringWithoutSpaces(String line){
		StringBuffer sb = new StringBuffer(""); 
		char tmp;
		if ((line == null) || line.equals("")) return "";
		int position;
		for (position = 0; position < line.length(); position++){
			/**
			 *       tmp
			 *            
			 */
			tmp = line.charAt(position);
			if (! ((tmp == ' ') || (tmp == '\t')) ){
				
				sb.append(tmp);
			}
		}
		return sb.toString();
	}
	
	public void getContent(ISkin skin, BufferedReader reader)throws ErrorReadingProject{
		try{
			String line;
    		//RGBColor tmp = new RGBColor();
    		for (int counter = 0; counter < 24 ; counter++){
    			
    			RGBColor tmp = new RGBColor();
    			try{
    				line = getStringWithoutSpaces(reader.readLine());
    			}catch(IOException e){
    				throw new ErrorReadingProject("   viscolor.txt");
    			}
    			
    			if (line.equals("")){
    				//     
    				try{
    					tmp.setRGBColor(-1,0,0);
    				}catch(InvalidValueException e){
    					throw new CodeError(" getContent()  ViscolorReader");
    				}
    			} else {
    				try{
    					tmp.encodeFromDecimal(line);
    				}catch(InvalidValueException e){
    					throw new InvalidFile("     viscolor.txt");
    				}
    			}
    			
   				skin.setViscolorColor(counter, tmp);
   				    			
    		}
   		}finally{
   			try{
   				reader.close();
   			}catch(IOException e){
   				throw new ErrorReadingProject("       getContent()  ViscolorReader");
   			}
       	}
	}
	
	
	public String getFileName(){
		return "viscolor.txt";
	}
}
